using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using Codeidea.UltraGraphics;

namespace StartProperty
{
	/// <summary>
	/// Form1 ժҪ˵
	/// </summary>
	public class MainForm : System.Windows.Forms.Form
	{
		private System.Windows.Forms.Panel panel1;
		private Codeidea.UltraGraphics.MyCAD myCAD1;
		private System.Windows.Forms.Button btnLine;
		private System.Windows.Forms.Button btnPolygon;
		private System.Windows.Forms.Button btnPolyLine;
		private System.Windows.Forms.ComboBox comboShapes;
		private System.Windows.Forms.Button btnDeleteShapes;
		/// <summary>
		/// 
		/// </summary>
		private System.ComponentModel.Container components = null;

		public MainForm()
		{
			//
			// Windows ֧
			//
			InitializeComponent();

			//
			// TODO:  InitializeComponent úκι캯
			//

		}

		/// <summary>
		/// ʹõԴ
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		public void RefreshCombo()
		{
			comboShapes.Items.Clear();
			if (myCAD1.GetShapesCount()>0)
			{
				for (Int32 i =0;i<myCAD1.GetShapesCount();++i)
				{
					comboShapes.Items.Add(myCAD1.GetShapeByNo(i).Name+":"+myCAD1.GetShapeByNo(i).ToString());
				}
			}
		}

		#region Windows ɵĴ
		/// <summary>
		/// ֧ķ - Ҫʹô༭޸
		/// ˷ݡ
		/// </summary>
		private void InitializeComponent()
		{
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(MainForm));
			this.panel1 = new System.Windows.Forms.Panel();
			this.myCAD1 = new Codeidea.UltraGraphics.MyCAD();
			this.btnLine = new System.Windows.Forms.Button();
			this.btnPolygon = new System.Windows.Forms.Button();
			this.btnPolyLine = new System.Windows.Forms.Button();
			this.comboShapes = new System.Windows.Forms.ComboBox();
			this.btnDeleteShapes = new System.Windows.Forms.Button();
			this.panel1.SuspendLayout();
			this.SuspendLayout();
			// 
			// panel1
			// 
			this.panel1.BackColor = System.Drawing.Color.Gray;
			this.panel1.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D;
			this.panel1.Controls.Add(this.myCAD1);
			this.panel1.Location = new System.Drawing.Point(8, 8);
			this.panel1.Name = "panel1";
			this.panel1.Size = new System.Drawing.Size(504, 304);
			this.panel1.TabIndex = 0;
			// 
			// myCAD1
			// 
			this.myCAD1.GridHeight = 40;
			this.myCAD1.GridWidth = 40;
			this.myCAD1.Location = new System.Drawing.Point(8, 8);
			this.myCAD1.Name = "myCAD1";
			this.myCAD1.PageHeight = 74;
			this.myCAD1.PageWidth = 127;
			this.myCAD1.Size = new System.Drawing.Size(480, 280);
			this.myCAD1.TabIndex = 0;
			this.myCAD1.ShapeAdded += new Codeidea.UltraGraphics.ShapeAddedEventHandler(this.myCAD1_ShapeAdded);
			this.myCAD1.Click += new System.EventHandler(this.myCAD1_Click);
			this.myCAD1.ShapeSelected += new Codeidea.UltraGraphics.ShapeSelectedEventHandler(this.myCAD1_ShapeSelected);
			// 
			// btnLine
			// 
			this.btnLine.BackColor = System.Drawing.SystemColors.Control;
			this.btnLine.Cursor = System.Windows.Forms.Cursors.Hand;
			this.btnLine.ForeColor = System.Drawing.Color.Gray;
			this.btnLine.Image = ((System.Drawing.Image)(resources.GetObject("btnLine.Image")));
			this.btnLine.Location = new System.Drawing.Point(40, 320);
			this.btnLine.Name = "btnLine";
			this.btnLine.Size = new System.Drawing.Size(24, 24);
			this.btnLine.TabIndex = 24;
			this.btnLine.TabStop = false;
			this.btnLine.Click += new System.EventHandler(this.btnLine_Click);
			// 
			// btnPolygon
			// 
			this.btnPolygon.BackColor = System.Drawing.SystemColors.Control;
			this.btnPolygon.Cursor = System.Windows.Forms.Cursors.Hand;
			this.btnPolygon.ForeColor = System.Drawing.Color.Gray;
			this.btnPolygon.Image = ((System.Drawing.Image)(resources.GetObject("btnPolygon.Image")));
			this.btnPolygon.Location = new System.Drawing.Point(104, 320);
			this.btnPolygon.Name = "btnPolygon";
			this.btnPolygon.Size = new System.Drawing.Size(24, 24);
			this.btnPolygon.TabIndex = 22;
			this.btnPolygon.TabStop = false;
			this.btnPolygon.Click += new System.EventHandler(this.btnPolygon_Click);
			// 
			// btnPolyLine
			// 
			this.btnPolyLine.BackColor = System.Drawing.SystemColors.Control;
			this.btnPolyLine.Cursor = System.Windows.Forms.Cursors.Hand;
			this.btnPolyLine.ForeColor = System.Drawing.Color.Gray;
			this.btnPolyLine.Image = ((System.Drawing.Image)(resources.GetObject("btnPolyLine.Image")));
			this.btnPolyLine.Location = new System.Drawing.Point(72, 320);
			this.btnPolyLine.Name = "btnPolyLine";
			this.btnPolyLine.Size = new System.Drawing.Size(24, 24);
			this.btnPolyLine.TabIndex = 21;
			this.btnPolyLine.TabStop = false;
			this.btnPolyLine.Click += new System.EventHandler(this.btnPolyLine_Click);
			// 
			// comboShapes
			// 
			this.comboShapes.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
			this.comboShapes.Location = new System.Drawing.Point(152, 320);
			this.comboShapes.Name = "comboShapes";
			this.comboShapes.Size = new System.Drawing.Size(360, 20);
			this.comboShapes.TabIndex = 25;
			this.comboShapes.SelectedValueChanged += new System.EventHandler(this.comboShapes_SelectedValueChanged);
			// 
			// btnDeleteShapes
			// 
			this.btnDeleteShapes.Location = new System.Drawing.Point(8, 352);
			this.btnDeleteShapes.Name = "btnDeleteShapes";
			this.btnDeleteShapes.Size = new System.Drawing.Size(120, 23);
			this.btnDeleteShapes.TabIndex = 26;
			this.btnDeleteShapes.Text = "Delete shapes";
			this.btnDeleteShapes.Click += new System.EventHandler(this.btnDeleteShapes_Click);
			// 
			// MainForm
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(6, 14);
			this.ClientSize = new System.Drawing.Size(536, 413);
			this.Controls.Add(this.btnDeleteShapes);
			this.Controls.Add(this.comboShapes);
			this.Controls.Add(this.btnLine);
			this.Controls.Add(this.btnPolygon);
			this.Controls.Add(this.btnPolyLine);
			this.Controls.Add(this.panel1);
			this.Name = "MainForm";
			this.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen;
			this.Text = "TCAD demo for .NET --- StartProperty";
			this.panel1.ResumeLayout(false);
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// Ӧóڵ㡣
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new MainForm());
		}


		private void btnLine_Click(object sender, System.EventArgs e)
		{
			myCAD1.DrawType = MyDrawType.Line;
		}

		private void btnPolyLine_Click(object sender, System.EventArgs e)
		{
			myCAD1.DrawType = MyDrawType.PolyLine;
		}

		private void btnPolygon_Click(object sender, System.EventArgs e)
		{
			myCAD1.DrawType = MyDrawType.Polygon;
		}

		private void myCAD1_ShapeAdded(object sender, Codeidea.UltraGraphics.ShapeAddedEventArgs e)
		{
			if (myCAD1.GetSelectedShape() != null)
			{
				comboShapes.Items.Add(myCAD1.GetSelectedShape().Name+":"+myCAD1.GetSelectedShape().ToString());
				comboShapes.SelectedIndex = comboShapes.Items.Count-1;
			}
		}

		private void btnDeleteShapes_Click(object sender, System.EventArgs e)
		{
			myCAD1.Delete();
			RefreshCombo();
		}

		private void myCAD1_ShapeSelected(object sender, Codeidea.UltraGraphics.ShapeSelectedEventArgs e)
		{
			if (e.SelectedShape != null)
			comboShapes.SelectedIndex = e.SelectedShape.ShapeNo;
		}

		private void myCAD1_Click(object sender, System.EventArgs e)
		{
			if (myCAD1.GetSelectedShape() == null)
				comboShapes.SelectedIndex = -1;
		}

		private void comboShapes_SelectedValueChanged(object sender, System.EventArgs e)
		{
			if (comboShapes.SelectedIndex != -1)
			myCAD1.SelectShapeByCode(myCAD1.GetShapeByNo(comboShapes.SelectedIndex).ShapeId,true);
		}

	}
}
